diff --git a/track_info.c b/track_info.c
index 04f48f6..d9fa28d 100644
--- a/track_info.c
+++ b/track_info.c
@@ -105,3 +105,54 @@ int track_info_matches(struct track_info *ti, const char *text, unsigned int fla
 	free_str_array(words);
 	return matched;
 }
+
+static int xstrcasecmp(const char *a, const char *b)
+{
+	if (a == NULL) {
+		if (b == NULL)
+			return 0;
+		return -1;
+	} else if (b == NULL) {
+		return 1;
+	}
+	return u_strcasecmp(a, b);
+}
+
+int track_info_cmp(const struct track_info *a, const struct track_info *b, const char * const *keys)
+{
+	int i, res = 0;
+
+	for (i = 0; keys[i]; i++) {
+		const char *key = keys[i];
+		const char *av, *bv;
+
+		/* numeric compare for tracknumber and discnumber */
+		if (strcmp(key, "tracknumber") == 0) {
+			res = comments_get_int(a->comments, key) -
+				comments_get_int(b->comments, key);
+			if (res)
+				break;
+			continue;
+		}
+		if (strcmp(key, "discnumber") == 0) {
+			res = comments_get_int(a->comments, key) -
+				comments_get_int(b->comments, key);
+			if (res)
+				break;
+			continue;
+		}
+		if (strcmp(key, "filename") == 0) {
+			/* NOTE: filenames are not necessarily UTF-8 */
+			res = strcasecmp(a->filename, b->filename);
+			if (res)
+				break;
+			continue;
+		}
+		av = comments_get_val(a->comments, key);
+		bv = comments_get_val(b->comments, key);
+		res = xstrcasecmp(av, bv);
+		if (res)
+			break;
+	}
+	return res;
+}
diff --git a/track_info.h b/track_info.h
index 9149dac..16ba284 100644
--- a/track_info.h
+++ b/track_info.h
@@ -54,4 +54,6 @@ extern int track_info_has_tag(const struct track_info *ti);
  */
 extern int track_info_matches(struct track_info *ti, const char *text, unsigned int flags);
 
+int track_info_cmp(const struct track_info *a, const struct track_info *b, const char * const *keys);
+
 #endif
diff --git a/tree.c b/tree.c
index 5c369cf..054bf53 100644
--- a/tree.c
+++ b/tree.c
@@ -8,6 +8,7 @@
 #include "comment.h"
 #include "utils.h"
 #include "debug.h"
+#include "as.h"
 
 struct searchable *tree_searchable;
 struct window *lib_tree_win;
@@ -365,6 +366,7 @@ struct track_info *tree_set_selected(void)
 	if (list_empty(&lib_artist_head))
 		return NULL;
 
+	as_hook(AS_TREE_ENTER);
 	tree_win_get_selected(&artist, &album);
 	if (album == NULL) {
 		/* only artist selected, track window is empty
@@ -485,7 +487,7 @@ static void album_add_track(struct album *album, struct tree_track *track)
 		const struct simple_track *a = (const struct simple_track *)track;
 		const struct simple_track *b = (const struct simple_track *)to_tree_track(item);
 
-		if (simple_track_cmp(&a->node, &b->node, album_track_sort_keys) < 0)
+		if (track_info_cmp(a->info, b->info, album_track_sort_keys) < 0)
 			break;
 	}
 	/* add before item */
@@ -514,8 +516,7 @@ void tree_add_track(struct tree_track *track)
 		album_name = "<No Name>";
 
 	if (albumartist) {
-		/* FIXME: user might want to create custom categories  */
-		artist_name = "<Compilations>";
+		artist_name = albumartist;
 	} else {
 		const char *compilation = comments_get_val(ti->comments, "compilation");
 
@@ -536,7 +537,7 @@ void tree_add_track(struct tree_track *track)
 			window_changed(lib_track_win);
 		}
 	} else if (artist) {
-		date = comments_get_int(ti->comments, "date");
+		date = comments_get_date(ti->comments, "date");
 		album = artist_add_album(artist, album_name, date);
 		album_add_track(album, track);
 
@@ -546,7 +547,7 @@ void tree_add_track(struct tree_track *track)
 			/* album is not selected => no need to update track_win */
 		}
 	} else {
-		date = comments_get_int(ti->comments, "date");
+		date = comments_get_date(ti->comments, "date");
 		artist = add_artist(artist_name);
 		album = artist_add_album(artist, album_name, date);
 		album_add_track(album, track);
diff --git a/ui_curses.c b/ui_curses.c
index 8d4febe..87eac1d 100644
--- a/ui_curses.c
+++ b/ui_curses.c
@@ -56,7 +56,7 @@
 #include <signal.h>
 #include <stdarg.h>
 
-#if defined(__sun__)
+#if defined(__sun__) || defined(__CYGWIN__)
 /* TIOCGWINSZ */
 #include <termios.h>
 #include <ncurses.h>
@@ -470,44 +470,6 @@ static inline void fopt_set_time(struct format_option *fopt, int value, int empt
 	fopt->empty = empty;
 }
 
-static void fill_track_fopts(struct tree_track *track)
-{
-	const char *filename;
-	const struct track_info *ti = tree_track_info(track);
-	int num, disc;
-
-	if (using_utf8) {
-		filename = ti->filename;
-	} else {
-		utf8_encode(ti->filename);
-		filename = conv_buffer;
-	}
-	disc = track->shuffle_track.simple_track.disc;
-	num = track->shuffle_track.simple_track.num;
-
-	fopt_set_str(&track_fopts[TF_ARTIST], track->album->artist->name);
-	fopt_set_str(&track_fopts[TF_ALBUM], track->album->name);
-	fopt_set_int(&track_fopts[TF_DISC], disc, disc == -1);
-	fopt_set_int(&track_fopts[TF_TRACK], num, num == -1);
-	fopt_set_str(&track_fopts[TF_TITLE], comments_get_val(ti->comments, "title"));
-	fopt_set_str(&track_fopts[TF_YEAR], comments_get_val(ti->comments, "date"));
-	fopt_set_str(&track_fopts[TF_GENRE], comments_get_val(ti->comments, "genre"));
-	fopt_set_time(&track_fopts[TF_DURATION], ti->duration, ti->duration == -1);
-	fopt_set_str(&track_fopts[TF_PATHFILE], filename);
-	if (is_url(ti->filename)) {
-		fopt_set_str(&track_fopts[TF_FILE], filename);
-	} else {
-		const char *f;
-
-		f = strrchr(filename, '/');
-		if (f) {
-			fopt_set_str(&track_fopts[TF_FILE], f + 1);
-		} else {
-			fopt_set_str(&track_fopts[TF_FILE], filename);
-		}
-	}
-}
-
 static void fill_track_fopts_track_info(struct track_info *info)
 {
 	char *filename;
@@ -563,7 +525,7 @@ static void print_track(struct window *win, int row, struct iter *iter)
 		cursor_y = 1 + row;
 	}
 
-	fill_track_fopts(track);
+	fill_track_fopts_track_info(tree_track_info(track));
 
 	if (track_info_has_tag(tree_track_info(track))) {
 		format_print(print_buffer, track_win_w, track_win_format, track_fopts);
@@ -1350,6 +1312,32 @@ void error_msg(const char *format, ...)
 	}
 }
 
+/*
+ * errno_msg()
+ *   print an error message plus the current errno message
+ */
+void
+errno_msg(const char *format, ...)
+{
+	/*
+	 * This function is a little limited, as is outputs lines of
+	 * MAX_ERR_LINE chars at most. It's useful, though, and could
+	 * probably be used more widespread.
+	 */
+	char buf[MAX_ERR_LINE];
+	va_list ap;
+	int  errno_save = errno;
+	int  n;
+
+	va_start(ap, format);
+	vsnprintf(buf, MAX_ERR_LINE, format, ap);
+	va_end(ap);
+	n = strlen(buf);
+	snprintf(buf + n, MAX_ERR_LINE - n, ": %s", strerror(errno_save));
+	strcat(buf, "\n");
+	error_msg(buf);
+}
+
 int yes_no_query(const char *format, ...)
 {
 	char buffer[512];
@@ -1981,7 +1969,7 @@ static void init_curses(void)
 		 * xterm:            xterm, xterm-{,16,88,256}color
 		 */
 		if (!strcmp(term, "screen")) {
-			t_ts = "\033k";
+			t_ts = "\033_";
 			t_fs = "\033\\";
 		} else if (!strncmp(term, "xterm", 5) ||
 			   !strncmp(term, "rxvt", 4) ||
diff --git a/ui_curses.h b/ui_curses.h
index 55e07e6..7f43960 100644
--- a/ui_curses.h
+++ b/ui_curses.h
@@ -23,6 +23,8 @@
 #include "search.h"
 #include "compiler.h"
 
+#define MAX_ERR_LINE 512
+
 enum ui_input_mode {
 	NORMAL_MODE,
 	COMMAND_MODE,
@@ -44,6 +46,7 @@ void update_colors(void);
 void update_full(void);
 void info_msg(const char *format, ...) __FORMAT(1, 2);
 void error_msg(const char *format, ...) __FORMAT(1, 2);
+void errno_msg(const char *format, ...) __FORMAT(1, 2);
 int yes_no_query(const char *format, ...) __FORMAT(1, 2);
 void search_not_found(void);
 void set_view(int view);
diff --git a/vorbis.c b/vorbis.c
index c60b995..da0ec8e 100644
--- a/vorbis.c
+++ b/vorbis.c
@@ -252,6 +252,10 @@ static int vorbis_read_comments(struct input_plugin_data *ip_data,
 			continue;
 		}
 		key = xstrndup(str, i);
+		if (!strcasecmp(key, "album_artist")) {
+			free(key);
+			key = xstrdup("albumartist");
+		}
 		if (!is_interesting_key(key)) {
 			free(key);
 			continue;
diff --git a/waveout.c b/waveout.c
new file mode 100644
index 0000000..e1b86bb
--- /dev/null
+++ b/waveout.c
@@ -0,0 +1,312 @@
+/* 
+ * Copyright 2007 dnk <dnk@bjum.net>
+ * Based on oss.c
+ * 
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ * 
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+ * 02111-1307, USA.
+ */
+
+#include "op.h"
+#include "sf.h"
+#include "utils.h"
+#include "xmalloc.h"
+#include "debug.h"
+
+#define WIN32_LEAN_AND_MEAN
+#include <windows.h>
+#include <mmsystem.h>
+
+static HWAVEOUT wave_out;
+static sample_format_t waveout_sf;
+static int buffer_size = 4096;
+static int buffer_count = 12;
+static WAVEHDR *buffers;
+static int buffer_idx;
+static int buffer_space;
+
+
+static void waveout_error(const char *name, int rc)
+{
+	const char *errstr = "UNKNOWN";
+
+	switch (rc) {
+	case MMSYSERR_ALLOCATED:	errstr = "MMSYSERR_ALLOCATED"; break;
+	case MMSYSERR_INVALHANDLE:	errstr = "MMSYSERR_INVALHANDLE"; break;
+	case MMSYSERR_NODRIVER:		errstr = "MMSYSERR_NODRIVER"; break;
+	case MMSYSERR_BADDEVICEID:	errstr = "MMSYSERR_BADDEVICEID"; break;
+	case MMSYSERR_NOMEM:		errstr = "MMSYSERR_NOMEM"; break;
+	case MMSYSERR_NOTSUPPORTED:	errstr = "MMSYSERR_NOTSUPPORTED"; break;
+	case WAVERR_STILLPLAYING:	errstr = "WAVERR_STILLPLAYING"; break;
+	case WAVERR_UNPREPARED:		errstr = "WAVERR_UNPREPARED"; break;
+	case WAVERR_BADFORMAT:		errstr = "WAVERR_BADFORMAT"; break;
+	case WAVERR_SYNC:		errstr = "WAVERR_SYNC"; break;
+	}
+
+	d_print("%s returned error %s (%d)\n", name, errstr, rc);
+}
+
+static void clean_buffers(void)
+{
+	int i;
+
+	/* mark used buffers clean */
+	for (i = 0; i < buffer_count; i++) {
+		WAVEHDR *hdr = &buffers[(buffer_idx + i) % buffer_count];
+
+		if (!(hdr->dwFlags & WHDR_DONE))
+			break;
+		buffer_space += hdr->dwBufferLength;
+		waveOutUnprepareHeader(wave_out, hdr, sizeof(WAVEHDR));
+		hdr->dwFlags = 0;
+	}
+}
+
+static int waveout_open(sample_format_t sf)
+{
+	WAVEFORMATEX  format;
+	int rc, i;
+
+	/* WAVEFORMATEX does not support channels > 2, waveOutWrite() wants little endian signed PCM */
+	if (sf_get_bigendian(sf) || !sf_get_signed(sf) || sf_get_channels(sf) > 2) {
+		return -OP_ERROR_SAMPLE_FORMAT;
+	}
+
+	memset(&format, 0, sizeof(format));
+	format.cbSize = sizeof(format);
+	format.wFormatTag = WAVE_FORMAT_PCM;
+	format.nChannels = sf_get_channels(sf);
+	format.nSamplesPerSec = sf_get_rate(sf);
+	format.wBitsPerSample = sf_get_bits(sf);
+	format.nAvgBytesPerSec = sf_get_second_size(sf);
+	format.nBlockAlign = sf_get_frame_size(sf);
+
+	if ((rc = waveOutOpen(&wave_out, WAVE_MAPPER, &format, 0, 0, CALLBACK_NULL)) != MMSYSERR_NOERROR) {
+		switch (rc) {
+		case MMSYSERR_ALLOCATED:
+			errno = EBUSY;
+			return -OP_ERROR_ERRNO;
+		case MMSYSERR_BADDEVICEID:
+		case MMSYSERR_NODRIVER:
+			errno = ENODEV;
+			return -OP_ERROR_ERRNO;
+		case MMSYSERR_NOMEM:
+			errno = ENOMEM;
+			return -OP_ERROR_ERRNO;
+		case WAVERR_BADFORMAT:
+			return -OP_ERROR_SAMPLE_FORMAT;
+		}
+		return -OP_ERROR_INTERNAL;
+	}
+
+	/* reset buffers */
+	for (i = 0; i < buffer_count; i++) {
+		buffers[i].dwFlags = 0;
+	}
+	buffer_idx = 0;
+	buffer_space = buffer_size * buffer_count;
+
+	waveout_sf = sf;
+
+	return 0;
+}
+
+static int waveout_close(void)
+{
+	int rc;
+
+	waveOutReset(wave_out);
+
+	clean_buffers();
+
+	if ((rc = waveOutClose(wave_out)) != MMSYSERR_NOERROR) {
+		waveout_error("waveOutClose", rc);
+		return -1;
+	}
+	wave_out = NULL;
+
+	return 0;
+}
+
+static int waveout_init(void)
+{
+	WAVEHDR *hdr;
+	int i;
+
+	/* create buffers */
+	buffers = xnew(WAVEHDR, buffer_count);
+	for (i = 0; i < buffer_count; i++) {
+		hdr = &buffers[i];
+
+		memset(hdr, 0, sizeof(WAVEHDR));
+		hdr->lpData = xmalloc(buffer_size);
+	}
+	return 0;
+}
+
+static int waveout_exit(void)
+{
+	int i;
+
+	for (i = 0; i < buffer_count; i++) {
+		free(buffers[i].lpData);
+	}
+	free(buffers);
+	buffers = NULL;
+
+	return 0;
+}
+
+static int waveout_write(const char *buffer, int count)
+{
+	int written = 0;
+	int len, rc;
+
+	count /= sf_get_frame_size(waveout_sf);
+	count *= sf_get_frame_size(waveout_sf);
+
+	clean_buffers();
+
+	while (count > 0) {
+		WAVEHDR *hdr = &buffers[buffer_idx];
+
+		if (hdr->dwFlags != 0) {
+			/* no free buffers */
+			break;
+		}
+
+		len = min(count, buffer_size);
+		hdr->dwBufferLength = len;
+		memcpy(hdr->lpData, buffer + written, len);
+
+		if ((rc = waveOutPrepareHeader(wave_out, hdr, sizeof(WAVEHDR))) != MMSYSERR_NOERROR) {
+			waveout_error("waveOutPrepareHeader", rc);
+			break;
+		}
+
+		if ((rc = waveOutWrite(wave_out, hdr, sizeof(WAVEHDR))) != MMSYSERR_NOERROR) {
+			waveOutUnprepareHeader(wave_out, hdr, sizeof(WAVEHDR));
+			hdr->dwFlags = 0;
+			waveout_error("waveOutWrite", rc);
+			break;
+		}
+ 
+		written += len;
+		count -= len;
+		buffer_idx = (buffer_idx + 1) % buffer_count;
+	}
+
+	buffer_space -= written;
+
+	return written;
+}
+
+static int waveout_pause(void)
+{
+	if (waveOutPause(wave_out) != MMSYSERR_NOERROR)
+		return -1;
+	return 0;
+}
+
+static int waveout_unpause(void)
+{
+	if (waveOutRestart(wave_out) != MMSYSERR_NOERROR)
+		return -1;
+	return 0;
+}
+
+static int waveout_buffer_space(void)
+{
+	clean_buffers();
+	if (buffer_space == 0)
+		return -1;
+	return buffer_space;
+}
+
+static int waveout_set_option(int key, const char *val)
+{
+	long int ival;
+	int reinit = 0;
+
+	switch (key) {
+	case 0:
+		if (str_to_int(val, &ival) || ival < 4096 || ival > 65536) {
+			errno = EINVAL;
+			return -OP_ERROR_ERRNO;
+		}
+		if (buffers) {
+			waveout_exit();
+			reinit = 1;
+		}
+		buffer_size = ival;
+		break;
+	case 1:
+		if (str_to_int(val, &ival) || ival < 2 || ival > 64) {
+			errno = EINVAL;
+			return -OP_ERROR_ERRNO;
+		}
+		if (buffers) {
+			waveout_exit();
+			reinit = 1;
+		}
+		buffer_count = ival;
+		break;
+	default:
+		return -OP_ERROR_NOT_OPTION;
+	}
+
+	if (reinit) {
+		waveout_init();
+	}
+
+	return 0;
+}
+
+static int waveout_get_option(int key, char **val)
+{
+	switch (key) {
+	case 0:
+		*val = xnew(char, 22);
+		snprintf(*val, 22, "%d", buffer_size);
+		break;
+	case 1:
+		*val = xnew(char, 22);
+		snprintf(*val, 22, "%d", buffer_count);
+		break;
+	default:
+		return -OP_ERROR_NOT_OPTION;
+	}
+	return 0;
+}
+
+const struct output_plugin_ops op_pcm_ops = {
+	.init = waveout_init,
+	.exit = waveout_exit,
+	.open = waveout_open,
+	.close = waveout_close,
+	.write = waveout_write,
+	.pause = waveout_pause,
+	.unpause = waveout_unpause,
+	.buffer_space = waveout_buffer_space,
+	.set_option = waveout_set_option,
+	.get_option = waveout_get_option
+};
+
+const char * const op_pcm_options[] = {
+	"buffer_size",
+	"buffer_count",
+	NULL
+};
+
+const int op_priority = 0;
